KickJS
====================================

## Description

A WebGL game engine for modern web-browsers. KickJS provides a game oriented abstraction of WebGL and makes game
programming in a browser easy.

## Examples

<a href="http://www.kickjs.org/example/chess/chess.html" title="KickJS Chess"><img src="http://www.kickjs.org/images/example_chess.jpg"></a>
<a href="http://www.kickjs.org/example/video_ascii_art/Video_Ascii_Art.html" title="Video ascii art"><img src="http://www.kickjs.org/images/example_video_ascii_art.jpg"></a>
<a href="http://www.kickjs.org/example/webcam_ascii_art/Webcam_Ascii_Art.html" title="WebCam ascii art"><img src="http://www.kickjs.org/images/example_webcam_ascii_art.jpg"></a>
<a href="http://www.kickjs.org/example/cloth_simulation/cloth_simulation.html" title="Cloth simulation"><img src="http://www.kickjs.org/images/example_cloth_simulation.jpg"></a>
<a href="http://www.kickjs.org/example/snake/snake.html" title="Snake"><img src="http://www.kickjs.org/images/example_snake.jpg"></a>
<a href="http://mortennobel.github.io/Unknown-Continents-2.0/" title="Unknown Continents v2.0"><img src="http://www.kickjs.org/images/example_unknown_continents_v2.0.jpg"></a>

## Tools
<a href="http://www.kickjs.org/tool/shader_editor/shader_editor.html" title="GLSL Editor"><img src="http://www.kickjs.org/images/example_glsl_editor.jpg"></a>
<a href="http://www.kickjs.org/tool/model_tool/model_tool.html" title="Model tool (Collada .dae and Wavefront .obj)"><img src="http://www.kickjs.org/images/example_collada_import.jpg"></a>

## Website and Documentation

Project website is:
http://www.kickjs.org/

API documentation:
http://www.kickjs.org/api/

(Offline usage can be found in KICK-doc.zip)

## Features:
 - Collada DAE and Wavefront OBJ models
 - Built-in shaders
 - Persistence model
 - View frustum culling
 - Shadow maps
 - Picking
 - Render to texture
 - Movie texture
 - Directional light, point lights and ambient lights
 - Event queue
 - Keyboard and mouse input
 - Serialization
 - Context lost handling
 - Skybox

## Getting started tutorial

Take a look at the <a href="http://www.kickjs.org/tutorial/index.html">tutorial</a>, which gives a gentle introduction to the concepts used in the game engine.

## Bugs, missing features and performance improvements

Checkout the issues section at GitHub
https://github.com/mortennobel/KickJS/issues

## License

New BSD License

Copyright (c) 2011-2013, Morten Nobel-Joergensen, Kickstart Games ( http://www.kickstartgames.com/ )
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
following conditions are met:

 - Redistributions of source code must retain the above copyright notice, this list of conditions and the following
 disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
 disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
